package models

type ARPRecord struct {
	Device     *Device `json:"-"`
	Address    string  `json:"address"`
	MacAddress string  `json:"mac-address"`
}

type UnmonitoredDevice struct {
	Address    string
	MacAddress string
}

func (d UnmonitoredDevice) Element() Element {
	return Element{
		Classes: []string{"unmonitored"},
		Data: ElementData{
			ID:    "unmonitored-" + d.MacAddress,
			Label: d.Address,
		},
	}
}
